import 'package:equatable/equatable.dart';
import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';

abstract class StoryBasic extends Equatable {
  final String id;

  StoryBasic(this.id);

  @override
  List<Object> get props => [id];
}

class StoryImageData extends StoryBasic {
  final String imagePath;

  StoryImageData(this.imagePath) : super(imagePath);

  StoryImageData.named({@required this.imagePath}) : super(imagePath);
}

class StoryVideoData extends StoryBasic {
  final String thumbnailPath;
  final String videoPath;

  StoryVideoData(this.thumbnailPath, this.videoPath) : super(videoPath);

  StoryVideoData.named({this.thumbnailPath, this.videoPath}) : super(videoPath);
}

class StorySmileyData extends StoryBasic {
  final String smileyPath;

  StorySmileyData({this.smileyPath}) : super(DateTime.now().toString());
}

class StoryTextData extends StoryBasic {
  static const EdgeInsets TEXT_PADDING = const EdgeInsets.all(12.0);

  final String data;
  final TextBoxDecoration decoration;

  StoryTextData({
    @required String id,
    @required this.data,
    @required this.decoration,
  }) : super(id);
}

class TextBoxDecoration {
  BoxDecoration decoration;
  TextStyle style;
  bool filled;
  TextAlign textAlign;
  TextBoxDecoration(
      {this.decoration,
      this.style,
      this.filled = false,
      this.textAlign = TextAlign.center});
}
